## ilmbase 2.5.4

=== OpenEXR_Viewers/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

cmake_minimum_required(VERSION 3.10)

if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

# we include this first to parse configure.ac and extract the version
# numbers
include(config/ParseConfigure.cmake)

project(OpenEXR_Viewers VERSION ${OPENEXR_VIEWERS_VERSION})

#######################################
#######################################
# This declares all the configuration variables visible
# in cmake-gui or similar and the rest of the global
# project setup
#
# Please look at this file to see what is configurable
#######################################
#######################################
include(config/OpenEXRViewersSetup.cmake)

find_package(IlmBase ${OPENEXR_VIEWERS_VERSION} EXACT REQUIRED CONFIG)
find_package(OpenEXR ${OPENEXR_VIEWERS_VERSION} EXACT REQUIRED CONFIG)

# This is for newer cmake versions who know about vendor versions
set(OpenGL_GL_PREFERENCE GLVND)
find_package(OpenGL)

set(FLTK_SKIP_FLUID 1)
find_package(FLTK)
if(FLTK_FOUND AND TARGET OpenGL::GL)
  add_subdirectory( exrdisplay )
else()
  if(NOT FLTK_FOUND)
    message(WARNING "FLTK not found, exrdisplay will not be built")
  endif()
  if(NOT OpenGL_FOUND)
    message(WARNING "OpenGL not found, exrdisplay will not be built")
  endif()
endif()

if(NOT WIN32)
  find_package(GLUT)
  # nvidia doesn't seem to provide one of these...
  #find_package(Cg)
  include(config/LocateCg.cmake)

  if(TARGET OpenGL::GLU AND TARGET Cg::CgGL AND TARGET GLUT::GLUT)
    add_subdirectory( playexr )
  endif()
else()
  message(NOTICE ": Disabling playexr, not yet ported to WIN32 platforms")
endif()

#[==[

##########################
# Installation
##########################

# Documentation
INSTALL ( FILES
  doc/OpenEXRViewers.pdf
  DESTINATION
  ${CMAKE_INSTALL_PREFIX}/share/doc/OpenEXR-${OPENEXR_VERSION}
  )

#]==]

=== IlmBase/IlmThread/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

ilmbase_define_library(IlmThread
  PRIV_EXPORT ILMTHREAD_EXPORTS
  CURDIR ${CMAKE_CURRENT_SOURCE_DIR}
  SOURCES
    IlmThread.cpp
    IlmThreadMutex.cpp
    IlmThreadMutexPosix.cpp
    IlmThreadPool.cpp
    IlmThreadPosix.cpp
    IlmThreadSemaphore.cpp
    IlmThreadSemaphorePosixCompat.cpp
    IlmThreadSemaphorePosix.cpp
    IlmThreadSemaphoreOSX.cpp
    IlmThreadMutexWin32.cpp
    IlmThreadSemaphoreWin32.cpp
    IlmThreadWin32.cpp
  HEADERS
    IlmThreadPool.h
    IlmThread.h
    IlmThreadSemaphore.h
    IlmThreadMutex.h
    IlmThreadNamespace.h
    IlmThreadExport.h
    IlmThreadForward.h
  DEPENDENCIES
    IlmBase::Iex
    Threads::Threads
  )

=== IlmBase/config/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckLibraryExists)
include(CheckStructHasMember)

check_include_files(ucontext.h ILMBASE_HAVE_UCONTEXT_H)
if(ILMBASE_HAVE_UCONTEXT_H)
  # TODO: remove this once we cleanly have ILMBASE_ prefix on all #defines
  set(HAVE_UCONTEXT_H ON)
  check_struct_has_member("struct _libc_fpstate" mxcsr ucontext.h ILMBASE_HAVE_CONTROL_REGISTER_SUPPORT)
  if(NOT ILMBASE_HAVE_CONTROL_REGISTER_SUPPORT)
    check_include_files(asm/sigcontext.h ILMBASE_HAVE_SIGCONTEXT_H)
    if(ILMBASE_HAVE_SIGCONTEXT_H)
      check_struct_has_member("struct _fpstate" mxcsr asm/sigcontext.h ILMBASE_HAVE_SIGCONTEXT_CONTROL_REGISTER_SUPPORT)
    endif()
  endif()
endif()

###check_include_files(pthread.h ILMBASE_HAVE_PTHREAD)
if(Threads_FOUND)
  if(CMAKE_HAVE_PTHREAD_H OR CMAKE_USE_PTHREADS_INIT OR CMAKE_HP_PTHREAD_INIT)
    set(ILMBASE_HAVE_PTHREAD ON)
    # TODO: remove this once we cleanly have ILMBASE_ prefix on all #defines
    set(HAVE_PTHREAD ON)
  endif()

  # we have threads, but do we have posix semaphores for sem_init?
  # should be in pthreads
  if(NOT (APPLE OR (WIN32 AND (NOT MINGW))))
    if(MINGW)
      check_include_files("pthread_unistd.h;semaphore.h" ILMBASE_HAVE_SEMAPHORE_H)
    else()
      check_include_files(semaphore.h ILMBASE_HAVE_SEMAPHORE_H)
    endif()
    if(ILMBASE_HAVE_SEMAPHORE_H AND ILMBASE_HAVE_PTHREAD)
      # should just be in libc, so no need for check_library_exists
      set(CMAKE_REQUIRED_FLAGS ${CMAKE_THREAD_LIBS_INIT})
      check_library_exists(pthread sem_init "" ILMBASE_HAVE_POSIX_SEMAPHORES)
      # TODO: remove this once we cleanly have ILMBASE_ prefix on all #defines
      if(ILMBASE_HAVE_POSIX_SEMAPHORES)
        set(HAVE_POSIX_SEMAPHORES ON)
      endif()
      set(CMAKE_REQUIRED_FLAGS)
    endif()
  endif()
endif()

if (ILMBASE_ENABLE_LARGE_STACK)
  set(ILMBASE_HAVE_LARGE_STACK ON)
endif()

configure_file(IlmBaseConfig.h.in_cmake ${CMAKE_CURRENT_BINARY_DIR}/IlmBaseConfig.h)
configure_file(IlmBaseConfigInternal.h.in_cmake ${CMAKE_CURRENT_BINARY_DIR}/IlmBaseConfigInternal.h)

add_library(IlmBaseConfig INTERFACE)
target_include_directories(IlmBaseConfig INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${ILMBASE_OUTPUT_SUBDIR}>)

install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/IlmBaseConfig.h
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}/${ILMBASE_OUTPUT_SUBDIR}
)

install(TARGETS IlmBaseConfig EXPORT ${PROJECT_NAME})
add_library(IlmBase::Config ALIAS IlmBaseConfig)

if(ILMBASE_INSTALL_PKG_CONFIG)
  # use a helper function to avoid variable pollution, but pretty simple
  function(ilmbase_pkg_config_help pcinfile)
    set(prefix ${CMAKE_INSTALL_PREFIX})
    set(exec_prefix "\${prefix}")
    set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
    set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
    set(LIB_SUFFIX_DASH ${ILMBASE_LIB_SUFFIX})
    if(TARGET Threads::Threads)
      # hrm, can't use properties as they end up as generator expressions
      # which don't seem to evaluate
      if(THREADS_HAVE_PTHREAD_ARG)
        set(PTHREAD_CFLAGS "-pthread")
      endif()
      set(PTHREAD_LIBS ${CMAKE_THREAD_LIBS_INIT})
    endif()
    string(REPLACE ".in" "" pcout ${pcinfile})
    configure_file(${pcinfile} ${CMAKE_CURRENT_BINARY_DIR}/${pcout} @ONLY)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${pcout}
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    )
  endfunction()
  ilmbase_pkg_config_help(../IlmBase.pc.in)
else()
  message(NOTICE "-- WARNING pkg-config generation disabled")
endif()

# The main export of the configuration - This is the
# moral equivalent of a pkg-config file for cmake
# and replaces the Find*.cmake of the "old" cmake
include(CMakePackageConfigHelpers)
configure_package_config_file(IlmBaseConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
write_basic_package_version_file("${PROJECT_NAME}ConfigVersion.cmake"
  VERSION ${ILMBASE_VERSION}
  COMPATIBILITY SameMajorVersion
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
install(EXPORT ${PROJECT_NAME}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
  FILE ${PROJECT_NAME}Targets.cmake
  NAMESPACE ${PROJECT_NAME}::
  EXPORT_LINK_INTERFACE_LIBRARIES
)

=== OpenEXR/IlmImf/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

openexr_define_library(IlmImf
  PRIV_EXPORT ILMIMF_EXPORTS
  CURDIR ${CMAKE_CURRENT_SOURCE_DIR}
  SOURCES
    b44ExpLogTable.h
    dwaLookups.h
    ImfAttribute.cpp
    ImfBoxAttribute.cpp
    ImfCRgbaFile.cpp
    ImfChannelList.cpp
    ImfChannelListAttribute.cpp
    ImfFloatAttribute.cpp
    ImfFrameBuffer.cpp
    ImfHeader.cpp
    ImfIO.cpp
    ImfInputFile.cpp
    ImfIntAttribute.cpp
    ImfLineOrderAttribute.cpp
    ImfMatrixAttribute.cpp
    ImfOpaqueAttribute.cpp
    ImfOutputFile.cpp
    ImfRgbaFile.cpp
    ImfStringAttribute.cpp
    ImfVecAttribute.cpp
    ImfHuf.cpp
    ImfThreading.cpp
    ImfWav.cpp
    ImfLut.cpp
    ImfCompressor.cpp
    ImfRleCompressor.cpp
    ImfZipCompressor.cpp
    ImfPizCompressor.cpp
    ImfB44Compressor.cpp
    ImfDwaCompressor.cpp
    ImfMisc.cpp
    ImfCompressionAttribute.cpp
    ImfDoubleAttribute.cpp
    ImfConvert.cpp
    ImfPreviewImage.cpp
    ImfPreviewImageAttribute.cpp
    ImfVersion.cpp
    ImfChromaticities.cpp
    ImfChromaticitiesAttribute.cpp
    ImfKeyCode.cpp
    ImfKeyCodeAttribute.cpp
    ImfTimeCode.cpp
    ImfTimeCodeAttribute.cpp
    ImfRational.cpp
    ImfRationalAttribute.cpp
    ImfFramesPerSecond.cpp
    ImfStandardAttributes.cpp
    ImfStdIO.cpp
    ImfEnvmap.cpp
    ImfEnvmapAttribute.cpp
    ImfScanLineInputFile.cpp
    ImfTiledInputFile.cpp
    ImfTiledMisc.cpp
    ImfTiledOutputFile.cpp
    ImfTiledRgbaFile.cpp
    ImfTileDescriptionAttribute.cpp
    ImfTileOffsets.cpp
    ImfRgbaYca.cpp
    ImfPxr24Compressor.cpp
    ImfTestFile.cpp
    ImfStringVectorAttribute.cpp
    ImfMultiView.cpp
    ImfAcesFile.cpp
    ImfMultiPartOutputFile.cpp
    ImfGenericOutputFile.cpp
    ImfOutputPartData.cpp
    ImfMultiPartInputFile.cpp
    ImfGenericInputFile.cpp
    ImfPartType.cpp
    ImfInputPartData.cpp
    ImfOutputPart.cpp
    ImfTiledOutputPart.cpp
    ImfInputPart.cpp
    ImfTiledInputPart.cpp
    ImfDeepScanLineInputPart.cpp
    ImfDeepScanLineOutputPart.cpp
    ImfDeepScanLineInputFile.cpp
    ImfDeepScanLineOutputFile.cpp
    ImfDeepTiledInputPart.cpp
    ImfDeepTiledOutputPart.cpp
    ImfDeepTiledInputFile.cpp
    ImfDeepTiledOutputFile.cpp
    ImfDeepFrameBuffer.cpp
    ImfDeepCompositing.cpp
    ImfCompositeDeepScanLine.cpp
    ImfDeepImageStateAttribute.cpp
    ImfFastHuf.cpp
    ImfFloatVectorAttribute.cpp
    ImfRle.cpp
    ImfSystemSpecific.cpp
    ImfZip.cpp
  HEADERS
    ImfForward.h
    ImfExport.h
    ImfAttribute.h
    ImfBoxAttribute.h
    ImfCRgbaFile.h
    ImfChannelList.h
    ImfChannelListAttribute.h
    ImfCompressionAttribute.h
    ImfDoubleAttribute.h
    ImfFloatAttribute.h
    ImfFrameBuffer.h
    ImfHeader.h
    ImfIO.h
    ImfInputFile.h
    ImfIntAttribute.h
    ImfLineOrderAttribute.h
    ImfMatrixAttribute.h
    ImfOpaqueAttribute.h
    ImfOutputFile.h
    ImfRgbaFile.h
    ImfStringAttribute.h
    ImfVecAttribute.h
    ImfHuf.h
    ImfWav.h
    ImfLut.h
    ImfArray.h
    ImfCompression.h
    ImfLineOrder.h
    ImfName.h
    ImfPixelType.h
    ImfVersion.h
    ImfXdr.h
    ImfConvert.h
    ImfPreviewImage.h
    ImfPreviewImageAttribute.h
    ImfChromaticities.h
    ImfChromaticitiesAttribute.h
    ImfKeyCode.h
    ImfKeyCodeAttribute.h
    ImfTimeCode.h
    ImfTimeCodeAttribute.h
    ImfRational.h
    ImfRationalAttribute.h
    ImfFramesPerSecond.h
    ImfStandardAttributes.h
    ImfStdIO.h
    ImfEnvmap.h
    ImfEnvmapAttribute.h
    ImfInt64.h
    ImfRgba.h
    ImfTileDescription.h
    ImfTileDescriptionAttribute.h
    ImfTiledInputFile.h
    ImfTiledOutputFile.h
    ImfTiledRgbaFile.h
    ImfRgbaYca.h
    ImfTestFile.h
    ImfThreading.h
    ImfB44Compressor.h
    ImfStringVectorAttribute.h
    ImfMultiView.h
    ImfAcesFile.h
    ImfMultiPartOutputFile.h
    ImfGenericOutputFile.h
    ImfMultiPartInputFile.h
    ImfGenericInputFile.h
    ImfPartType.h
    ImfPartHelper.h
    ImfOutputPart.h
    ImfTiledOutputPart.h
    ImfInputPart.h
    ImfTiledInputPart.h
    ImfDeepScanLineOutputFile.h
    ImfDeepScanLineOutputPart.h
    ImfDeepScanLineInputFile.h
    ImfDeepScanLineInputPart.h
    ImfDeepTiledInputFile.h
    ImfDeepTiledInputPart.h
    ImfDeepTiledOutputFile.h
    ImfDeepTiledOutputPart.h
    ImfDeepFrameBuffer.h
    ImfDeepCompositing.h
    ImfCompositeDeepScanLine.h
    ImfNamespace.h
    ImfDeepImageState.h
    ImfDeepImageStateAttribute.h
    ImfFloatVectorAttribute.h
  DEPENDENCIES
    OpenEXR::Config
    IlmBase::Iex
    IlmBase::Half
    IlmBase::Imath
    IlmBase::IlmThread
    ZLIB::ZLIB
  )

=== OpenEXR/IlmImfFuzzTest/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

option(OPENEXR_RUN_FUZZ_TESTS  "Controls whether to include the fuzz tests (slow) in default test cases, there is a custom fuzz target" OFF)
if(OPENEXR_RUN_FUZZ_TESTS)
  add_executable( IlmImfFuzzTest
    fuzzFile.cpp
    main.cpp
    testFuzzDeepTiles.cpp
    testFuzzDeepScanLines.cpp
    testFuzzScanLines.cpp
    testFuzzTiles.cpp
  )
  target_link_libraries(IlmImfFuzzTest OpenEXR::IlmImf)
  set_target_properties(IlmImfFuzzTest PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
  )
  add_test(NAME OpenEXR.ImfFuzz COMMAND $<TARGET_FILE:IlmImfFuzzTest>)
  set_tests_properties(OpenEXR.ImfFuzz PROPERTIES TIMEOUT 36000)

  add_custom_target(fuzz $<TARGET_FILE:IlmImfFuzzTest>)
  add_dependencies(fuzz IlmImfFuzzTest)
endif()

=== OpenEXR/config/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckLibraryExists)
include(CheckStructHasMember)
include(CheckCXXSourceCompiles)

if (NOT CMAKE_CROSSCOMPILING AND EXISTS "/proc/self/exe")
  set(OPENEXR_IMF_HAVE_LINUX_PROCFS TRUE)
endif()

check_cxx_source_compiles(
"
#include <unistd.h>
int main()
{
    sysconf(_SC_NPROCESSORS_ONLN);
}
" OPENEXR_IMF_HAVE_SYSCONF_NPROCESSORS_ONLN
)    

check_cxx_source_compiles(
"
int main()
{
#if defined(__SSE2__)
    int n   = 0;
    int eax = 0;
    int edx = 0;
    __asm__(
        \"xgetbv     ;\"
        \"vzeroupper  \"
        : \"=a\"(eax), \"=d\"(edx) : \"c\"(n) : );
#else
#    error No SSE support enabled to query AVX support
#endif
}
" OPENEXR_IMF_HAVE_GCC_INLINE_ASM_AVX
)


# This is no longer something that needs to be tested if we have
# C++14 support...
set(OPENEXR_IMF_HAVE_COMPLETE_IOMANIP TRUE)

if(APPLE)
  set(OPENEXR_IMF_HAVE_DARWIN TRUE)
  if (${CMAKE_OSX_ARCHITECTURES} MATCHES arm64)
    set(OPENEXR_IMF_HAVE_GCC_INLINE_ASM_AVX FALSE)
  endif()
endif()

configure_file(OpenEXRConfig.h.in_cmake ${CMAKE_CURRENT_BINARY_DIR}/OpenEXRConfig.h)
configure_file(OpenEXRConfigInternal.h.in_cmake ${CMAKE_CURRENT_BINARY_DIR}/OpenEXRConfigInternal.h)

add_library(IlmImfConfig INTERFACE)
target_include_directories(IlmImfConfig INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${OPENEXR_OUTPUT_SUBDIR}>)

install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/OpenEXRConfig.h
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}/${OPENEXR_OUTPUT_SUBDIR}
)

install(TARGETS IlmImfConfig EXPORT ${PROJECT_NAME})
add_library(${PROJECT_NAME}::Config ALIAS IlmImfConfig)

if(OPENEXR_INSTALL_PKG_CONFIG)
  # use a helper function to avoid variable pollution, but pretty simple
  function(openexr_pkg_config_help pcinfile)
    set(prefix ${CMAKE_INSTALL_PREFIX})
    set(exec_prefix "\${prefix}")
    set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
    set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
    set(LIB_SUFFIX_DASH ${OPENEXR_LIB_SUFFIX})
    if(TARGET Threads::Threads)
      # hrm, can't use properties as they end up as generator expressions
      # which don't seem to evaluate
      if(THREADS_HAVE_PTHREAD_ARG)
        set(PTHREAD_CFLAGS "-pthread")
      endif()
      set(PTHREAD_LIBS ${CMAKE_THREAD_LIBS_INIT})
    endif()
    string(REPLACE ".in" "" pcout ${pcinfile})
    configure_file(${pcinfile} ${CMAKE_CURRENT_BINARY_DIR}/${pcout} @ONLY)
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${pcout}
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    )
  endfunction()
  openexr_pkg_config_help(../OpenEXR.pc.in)
endif()

# The main export of the configuration - This is the
# moral equivalent of a pkg-config file for cmake
# and replaces the Find*.cmake of the "old" cmake
include(CMakePackageConfigHelpers)
configure_package_config_file(OpenEXRConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
write_basic_package_version_file("${PROJECT_NAME}ConfigVersion.cmake"
  VERSION ${OPENEXR_VERSION}
  COMPATIBILITY SameMajorVersion
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
install(EXPORT ${PROJECT_NAME}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
  FILE ${PROJECT_NAME}Targets.cmake
  NAMESPACE ${PROJECT_NAME}::
  EXPORT_LINK_INTERFACE_LIBRARIES
)

=== OpenEXR/doc/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

install(
  FILES
    TechnicalIntroduction.pdf
    ReadingAndWritingImageFiles.pdf
    OpenEXRFileLayout.pdf
    MultiViewOpenEXR.pdf
    InterpretingDeepPixels.pdf
    TheoryDeepPixels.pdf
  DESTINATION
    ${CMAKE_INSTALL_DOCDIR}
)

=== OpenEXR/exr2aces/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

add_executable(exr2aces main.cpp)
target_link_libraries(exr2aces OpenEXR::IlmImf)
set_target_properties(exr2aces PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
)
install(TARGETS exr2aces DESTINATION ${CMAKE_INSTALL_BINDIR})
if(WIN32 AND (BUILD_SHARED_LIBS OR OPENEXR_BUILD_BOTH_STATIC_SHARED))
  target_compile_definitions(exr2aces PRIVATE OPENEXR_DLL)
endif()

=== OpenEXR/exrheader/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

add_executable(exrheader main.cpp)
target_link_libraries(exrheader OpenEXR::IlmImf)
set_target_properties(exrheader PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
)
install(TARGETS exrheader DESTINATION ${CMAKE_INSTALL_BINDIR})
if(WIN32 AND (BUILD_SHARED_LIBS OR OPENEXR_BUILD_BOTH_STATIC_SHARED))
  target_compile_definitions(exrheader PRIVATE OPENEXR_DLL)
endif()

=== OpenEXR/exrmultipart/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

add_executable(exrmultipart exrmultipart.cpp)
target_link_libraries(exrmultipart OpenEXR::IlmImf)
set_target_properties(exrmultipart PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
)
install(TARGETS exrmultipart DESTINATION ${CMAKE_INSTALL_BINDIR})
if(WIN32 AND (BUILD_SHARED_LIBS OR OPENEXR_BUILD_BOTH_STATIC_SHARED))
  target_compile_definitions(exrmultipart PRIVATE OPENEXR_DLL)
endif()

=== PyIlmBase/PyIex/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

pyilmbase_define_module(iex
  LIBNAME PyIex
  PRIV_EXPORT PYIEX_BUILD
  CURDIR ${CMAKE_CURRENT_SOURCE_DIR}
  LIBSOURCE
    PyIex.cpp
  MODSOURCE
    iexmodule.cpp
  HEADERS
    PyIex.h
    PyIexExport.h
    PyIexTypeTranslator.h
  DEPENDENCIES
    IlmBase::Iex IlmBase::IexMath
  )

=== PyIlmBase/PyImathNumpyTest/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

if(TARGET Python2::Interpreter)
  add_test(PyIlmBase.PyImathNumpyTest_Python2
    ${Python2_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/pyImathNumpyTest.in
  )
  set_tests_properties(PyIlmBase.PyImathNumpyTest_Python2 PROPERTIES
    ENVIRONMENT "PYTHONPATH=${CMAKE_BINARY_DIR}/python${Python2_VERSION_MAJOR}_${Python2_VERSION_MINOR}"
  )
endif()

if(TARGET Python3::Interpreter)
  add_test(PyIlmBase.PyImathNumpyTest_Python3
    ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/pyImathNumpyTest.in
  )
  set_tests_properties(PyIlmBase.PyImathNumpyTest_Python3 PROPERTIES
    ENVIRONMENT "PYTHONPATH=${CMAKE_BINARY_DIR}/python${Python3_VERSION_MAJOR}_${Python3_VERSION_MINOR}"
  )
endif()

=== debian/changelog ===
ilmbase (2.5.4-1) unstable; urgency=medium

  * New upstream release
  * debian/watch: parameters updated
  * debian/control: S-V bump 4.5.0 -> 4.5.1 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Thu, 21 Jan 2021 23:08:33 +0100

=== debian/control ===
Source: ilmbase
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Mathieu Malaterre <malat@debian.org>,
 Matteo F. Vescovi <mfv@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dpkg-dev (>= 1.16.1)
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: http://www.openexr.com
Vcs-Git: https://salsa.debian.org/debian-phototools-team/ilmbase.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/ilmbase

Package: libilmbase25
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends:
 ${misc:Pre-Depends}
Replaces: libilmbase23 (>= 2.3)
Breaks: libilmbase23 (>= 2.3)
Description: several utility libraries from ILM used by OpenEXR
 IlmBase are a set of utility libraries released by ILM, and used in
 their OpenEXR implementation. Included in this package you can find:
 .
  * libHalf: a class (Half) for manipulating "half" values (16-bit
    floating point format) as if they were a built-in C++ data type.
 .
  * libIlmThread: a thread abstraction library on top of pthreads.
 .
  * libImath: a math library with support for matrices, 2d- and
    3d-transformations, solvers for linear/quadratic/cubic equations,
    and more.
 .
  * libIex: an exception handling library.

Package: libilmbase-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libilmbase25 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends:
 ${misc:Pre-Depends}
Replaces: libopenexr-dev (<< 1.6)
Breaks: libopenexr-dev (<< 1.6)
Description: development files for IlmBase
 This package provides the development files for IlmBase, a set of
 utility libraries released by ILM and used by OpenEXR. Install this
 package if you want to compile a program that makes use of these
 libraries.

=== debian/rules ===
#! /usr/bin/make -f
#
# © 2009 Cyril Brulebois <kibi@debian.org>


##### VARIABLES
#

DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
#NO_MAKE_CHECK_ARCHS := arm
NO_FAIL_ON_TESTSUITE_ERROR := i386

ifeq (,$(filter $(DEB_BUILD_ARCH),alpha))
	export DEB_CFLAGS_MAINT_APPEND=-Wall
	export DEB_CXXFLAGS_MAINT_APPEND=-Wall
else
	export DEB_CFLAGS_MAINT_APPEND=-Wall -mieee
	export DEB_CXXFLAGS_MAINT_APPEND=-Wall -mieee
endif

##### OVERRIDES
#

override_dh_autoreconf:
	dh_autoreconf -- bash ./bootstrap

# Need to set an environment variable to make sure proper linking
# against libphtread happens:
override_dh_auto_configure:
	PTHREAD_LIBS=-lpthread \
		$(shell dpkg-buildflags --export=configure) \
		dh_auto_configure -v

# Need to disable the test suite on some architectures:
override_dh_auto_test:
ifeq (,$(filter $(DEB_BUILD_ARCH),$(NO_MAKE_CHECK_ARCHS)))
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_BUILD_ARCH),$(NO_FAIL_ON_TESTSUITE_ERROR)))
	dh_auto_test -v
else
	dh_auto_test -v || echo TESTSUITE FAILED, continuing anyway.
endif
endif
endif

# Need to install those in both packages:
override_dh_installdocs:
	dh_installdocs README.md

override_dh_auto_install:
	dh_auto_install
	# see #841444
	sed -i /ILMBASE_HAVE_CONTROL_REGISTER_SUPPORT/d debian/tmp/usr/include/OpenEXR/IlmBaseConfig.h

# Need to pass -V to dh_makeshlibs:
override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_clean:
	dh_clean */Makefile
	dh_clean IlmBase.pc
	dh_clean Makefile
	dh_clean config.log
	dh_clean config.status
	dh_clean config/stamp-h1
	dh_clean libtool

# Everything else:
%:
	dh $@ -Bbuild -DIlmBase -Scmake

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ilmbase-$1\.tar\.gz/, \
pgpsigurlmangle=s/archive\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc" \
https://github.com/AcademySoftwareFoundation/openexr/tags .*/v?(\d\S+)\.tar\.gz

## ilmbase 2.5.7

=== IlmBase/IexMath/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

ilmbase_define_library(IexMath
  PRIV_EXPORT IEXMATH_EXPORTS
  CURDIR ${CMAKE_CURRENT_SOURCE_DIR}
  SOURCES
    IexMathFloatExc.cpp
    IexMathFpu.cpp
  HEADERS
    IexMathFloatExc.h
    IexMathFpu.h
    IexMathIeeeExc.h
  DEPENDENCIES
    IlmBase::Iex
  )

=== IlmBase/ImathTest/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

add_executable(ImathTest 
  main.cpp
  testBox.cpp
  testBoxAlgo.cpp
  testColor.cpp
  testExtractEuler.cpp
  testExtractSHRT.cpp
  testFrustum.cpp
  testFrustumTest.cpp
  testFun.cpp
  testInvert.cpp
  testJacobiEigenSolver.cpp
  testLineAlgo.cpp
  testMatrix.cpp
  testMiscMatrixAlgo.cpp
  testProcrustes.cpp
  testQuat.cpp
  testQuatSetRotation.cpp
  testQuatSlerp.cpp
  testRandom.cpp
  testRoots.cpp
  testShear.cpp
  testTinySVD.cpp
  testVec.cpp
)

target_link_libraries(ImathTest IlmBase::Imath)
set_target_properties(ImathTest PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
)
if(WIN32 AND (BUILD_SHARED_LIBS OR OPENEXR_BUILD_BOTH_STATIC_SHARED))
  target_compile_definitions(ImathTest PRIVATE OPENEXR_DLL)
endif()
add_test(NAME IlmBase.Imath COMMAND $<TARGET_FILE:ImathTest>)

=== IlmBase/config/CMakeLists.txt ===
--- 
+++ 
@@ -78,7 +78,8 @@
     set(exec_prefix "\${prefix}")
     set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
     set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
-    set(LIB_SUFFIX_DASH ${ILMBASE_LIB_SUFFIX})
+    string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
+    set(LIB_SUFFIX_DASH ${ILMBASE_LIB_SUFFIX}${CMAKE_${uppercase_CMAKE_BUILD_TYPE}_POSTFIX})
     if(TARGET Threads::Threads)
       # hrm, can't use properties as they end up as generator expressions
       # which don't seem to evaluate

=== OpenEXR/IlmImfUtilTest/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

add_executable(IlmImfUtilTest
  main.cpp
  testFlatImage.cpp
  testDeepImage.cpp
  testIO.cpp
 )
target_link_libraries(IlmImfUtilTest OpenEXR::IlmImfUtil)
set_target_properties(IlmImfUtilTest PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
)
if(WIN32 AND (BUILD_SHARED_LIBS OR OPENEXR_BUILD_BOTH_STATIC_SHARED))
  target_compile_definitions(IlmImfUtilTest PRIVATE OPENEXR_DLL)
endif()
add_test(NAME OpenEXR.IlmImfUtil COMMAND $<TARGET_FILE:IlmImfUtilTest>)

=== OpenEXR/exrstdattr/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

add_executable(exrstdattr main.cpp)
target_link_libraries(exrstdattr OpenEXR::IlmImf)
set_target_properties(exrstdattr PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
)
install(TARGETS exrstdattr DESTINATION ${CMAKE_INSTALL_BINDIR})
if(WIN32 AND (BUILD_SHARED_LIBS OR OPENEXR_BUILD_BOTH_STATIC_SHARED))
  target_compile_definitions(exrstdattr PRIVATE OPENEXR_DLL)
endif()

=== OpenEXR_Viewers/playexr/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenEXR Project.

add_executable(playexr
  main.cpp 
  playExr.cpp
  playExr.h
  fileNameForFrame.cpp
  fileNameForFrame.h
  FileReadingThread.cpp
  FileReadingThread.h
  ImageBuffers.cpp
  ImageBuffers.h
  Timer.cpp
  Timer.h
  ctlToLut.cpp
  ctlToLut.h
  osDependent.cpp
  osDependent.h 
)

target_link_libraries(playexr
  Cg::CgGL
  GLUT::GLUT
  OpenGL::GL
  OpenGL::GLU
  OpenEXR::IlmImf
)
set_target_properties(playexr PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin"
)

install(TARGETS playexr DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
ilmbase (2.5.7-2) unstable; urgency=medium

  [ Pino Toscano ]
  * debian/rules: ignore testsuite failures also on non-Linux i386 archs

  [ Matteo F. Vescovi ]
  * debian/control: S-V bump 4.5.1 -> 4.6.0 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 18 Sep 2021 00:16:00 +0200

ilmbase (2.5.7-1) unstable; urgency=medium

  * New upstream release
  * debian/watch: narrow down upstream versions

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 28 Aug 2021 15:27:05 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  cmake,
  debhelper-compat (= 13),
  dpkg-dev (>= 1.16.1)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://www.openexr.com
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/ilmbase.git

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 #NO_MAKE_CHECK_ARCHS := arm
-NO_FAIL_ON_TESTSUITE_ERROR := i386
+NO_FAIL_ON_TESTSUITE_ERROR := i386 hurd-i386 kfreebsd-i386
 
 ifeq (,$(filter $(DEB_BUILD_ARCH),alpha))
 	export DEB_CFLAGS_MAINT_APPEND=-Wall

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ilmbase-$1\.tar\.gz/, \
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/, \
pgpsigurlmangle=s/archive\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc" \
https://github.com/AcademySoftwareFoundation/openexr/tags .*/v?(\d\S+)\.tar\.gz
